#include "dynet/dim.h"

#include <iostream>

using namespace std;

namespace dynet {

ostream& operator<<(ostream& os, const Dim& d) {
  os << '{';
  for (unsigned i = 0; i < d.nd; ++i) {
    if (i) os << ',';
    os << d.d[i];
  }
  if(d.bd != 1) os << 'X' << d.bd;
  return os << '}';
}

void Dim::print_profile(ostream& os) const {
  os << '{';
  for (unsigned i = 0; i < nd; ++i) {
    if (i) os << ',';
    os << d[i];
  }
  os << '}';
}

ostream& operator<<(ostream& os, const vector<Dim>& ds) {
  os << '[';
  for (unsigned i = 0; i < ds.size(); ++i)
    os << (i ? " " : "") << ds[i];
  return os << ']';
}

DYNET_SERIALIZE_COMMIT(Dim, DYNET_SERIALIZE_DEFINE(nd, d))
DYNET_SERIALIZE_IMPL(Dim)

} // namespace dynet

